/******************************************************************************
;  *   	@MCU				 : MC51F003A4
;  *   	@Create Date         : 2021.10.11
;  *   	@Author/Corporation  : Martin/SinoMCU
;  *   	@΢֧QQ 	 : 2048615934
;  *    @΢		     : http://www.sinomcu.com/
;  *   	@Copyright           : 2020 SINOMCU Corporation,All Rights Reserved.
;  *----------------------Abstract Description---------------------------------
;  *			          AD⣬úʹã²Ҫ޸                                		
******************************************************************************/
#include "ADC_LIB.h"

void ADC_StructInit(ADC_InitTypeDef *ADCInitStr)
{
	ADCInitStr->ADC_clock_division     = ADC_CKS_DIV_1;
	ADCInitStr->ADC_sam_time           = ADC_SAM_TIME_15ADCLK;
	ADCInitStr->ADC_IOx                = 0x0000U;
	ADCInitStr->ADC_chx                = ADC_CHGND;
	ADCInitStr->ADC_data_sel           = ADC_DATA_SEL_8H_4L;
	ADCInitStr->ADC_vref               = ADC_VREF_VDD;
	ADCInitStr->ADC_interrupt          = 0x00U;
	ADCInitStr->ADC_interrupt_priority = 0x00U;
	
}
/************************************************
;  *    @Function Name       : ADC_Init
;  *    @Description         : 
;  *    @IN_Parameter      	 :  ADCx ADò
;  *    @Return parameter    :
;  ***********************************************/
void ADC_Init(ADC_InitTypeDef *ADCx)
{
    ADCCR0 = REG_CLR;
    ADCCR1 = REG_CLR;
    ADRIOS0 = REG_CLR;
    ADRIOS1 = REG_CLR; //Ĵ0

    if (ADCx->ADC_vref == ADC_VREF_EXT_VREF) //ѡⲿοѹ
    {
        ADRIOS1 |= DEF_SET_BIT5; //ѡⲿοѹ
        //Vref(P20)Ч,ADCģǿƽVrefѹΪADĲοѹʹ,
        //ʱADCοѹѡλVRS[1:0]ֵ
    }
    ADCCR0 |= (ADCx->ADC_chx | ADCx->ADC_vref);                                     //ͨ/οѹ
    ADCCR1 |= (ADCx->ADC_data_sel | ADCx->ADC_clock_division | ADCx->ADC_sam_time); //ݸʽ/ADʱ/ʱ
    ADRIOS0 |= ADCx->ADC_IOx & 0x00ff;
    ADRIOS1 |= ADCx->ADC_IOx >> 8;     //IO
    if (ADCx->ADC_interrupt == ENABLE) //ʹADCж
    {
        IP &= ~ADC_INT_PRI_ADDR;
        IPH &= ~ADC_INT_PRI_ADDR;    //жȼ
        ADCIE = ADCx->ADC_interrupt; //ADCж
        if (ADCx->ADC_interrupt_priority == HIGH)
        {
            IP |= ADC_INT_PRI_ADDR; //жȼ
        }
    }
    else
    {
        ADCIE = ADCx->ADC_interrupt; //ADCж
        IP &= ~ADC_INT_PRI_ADDR;
        IPH &= ~ADC_INT_PRI_ADDR; //жȼ
    }
}
/************************************************
;  *    @Function Name       : ADC_Cmd
;  *    @Description         : AD ʹλ
;  *    @IN_Parameter      	 :
;  *    @Return parameter    :
;  ***********************************************/
void ADC_Cmd(uint8_t newstate)
{
    if (newstate == ENABLE)
        SET_ADEN(); //ʹADCģ
    else
        CLR_ADEN(); //رADCģ
}
/************************************************
;  *    @Function Name       : ADC_IO_Configure
;  *    @Description         : AD IO
;  *    @IN_Parameter      	 :
;  *    @Return parameter    :
;  ***********************************************/
void ADC_IOConfigure(uint16_t IOX)
{
    ADRIOS0 = REG_CLR;                         //
    ADRIOS1 &= ~(DEF_SET_BIT1 | DEF_SET_BIT0); //
    ADRIOS0 |= IOX & 0xff;                     //IO
    ADRIOS1 |= IOX >> 8;                       //IO
}
/************************************************
;  *    @Function Name       : ADC_Channel_Configure
;  *    @Description         : AD ͨ
;  *    @IN_Parameter      	 :
;  *    @Return parameter    :
;  ***********************************************/
void ADC_Channel_Configure(uint8_t CH)
{
    ADCCR0 &= ~ADC_CHX_ADDR;
    ADCCR0 |= CH;
}
/************************************************
;  *    @Function Name       : ADC_Value_4H_8L
;  *    @Description         : ȡADCֵ 
;  *    @IN_Parameter      	 :
;  *    @Return parameter    :
;  ***********************************************/
uint16_t ADC_Value_4H_8L(void)
{
    uint16_t temp = 0;
    temp = ADRH << 8;
    temp += ADRL;
    return temp;
}
/************************************************
;  *    @Function Name       : ADC_Value_8H_4L
;  *    @Description         : ȡADCֵ 
;  *    @IN_Parameter      	 :
;  *    @Return parameter    :
;  ***********************************************/
uint16_t ADC_Value_8H_4L(void)
{
    uint16_t temp = 0;
    temp = ADRH << 4;
    temp = temp + ADRL;
    return temp;
}
/************************************************
;  *    @Function Name       : ADC_StartOneConversion
;  *    @Description         : һת 
;  *    @IN_Parameter      	 :
;  *    @Return parameter    :
;  ***********************************************/
void ADC_Start_One_Conversion(void)
{
    CLR_ADEOC(); //ת
}
/************************************************
;  *    @Function Name       : ADC_GetFlagStatus
;  *    @Description         : ȡת־λ 
;  *    @IN_Parameter      	 :
;  *    @Return parameter    :
;  ***********************************************/
flagstatus ADC_Get_FlagStatus(void)
{
    flagstatus bitstatus = RESET;
    if ((ADCCR0 & ADC_ADEOC_ADDR) != (uint8_t)RESET)
    {
        bitstatus = SET;
    }
    else
    {
        bitstatus = RESET;
    }
    return bitstatus;
}

/**************************** end of file *********************************************/
