/******************************************************************************
;  *   	@MCU				 : MC51F003A4
;  *   	@Create Date         : 2021.10.11
;  *   	@Author/Corporation  : Martin/SinoMCU
;  *   	@΢֧QQ 	 : 2048615934
;  *    @΢		     : http://www.sinomcu.com/
;  *   	@Copyright           : 2020 SINOMCU Corporation,All Rights Reserved.
;  *----------------------Abstract Description---------------------------------
;  *			          W25Q64                              		
******************************************************************************/

#include "w25qxx.h"
#include "SPI.h"

//4KbytesΪһSector
//16Ϊ1Block
//W25Q128
//Ϊ16Mֽ,128Block,4096Sector

/************************************************
;  *    @Function Name       : W25QXX_Init
;  *    @Description         : ʼflash
;  *    @IN_Parameter        :
;  *    @Return parameter    :
;  ***********************************************/
void W25QXX_Init(void)
{
	W25QXX_CS = 1;   //SPI FLASHѡ
	SPI_User_Init(); //ʼSPI
}
/************************************************
;  *    @Function Name       : W25QXX_ReadSR
;  *    @Description         : ȡW25QXX״̬Ĵ
;  *    @IN_Parameter        :	
;  *    @Return parameter    :	BIT7  6   5   4   3   2   1   0
								SPR   RV  TB BP2 BP1 BP0 WEL BUSY
								SPR:Ĭ0,״̬Ĵλ,WPʹ
								TB,BP2,BP1,BP0:FLASHд
								WEL:дʹ
								BUSY:æλ(1,æ;0,)
								Ĭ:0x00
;  ***********************************************/
uint8_t W25QXX_ReadSR(void)
{
	uint8_t byte = 0;
	W25QXX_CS = 0;							//ʹ
	SPI1_ReadWriteByte(W25X_ReadStatusReg); //Ͷȡ״̬Ĵ
	byte = SPI1_ReadWriteByte(0Xff);		//ȡһֽ
	W25QXX_CS = 1;							//ȡƬѡ
	return byte;
}
/************************************************
;  *    @Function Name       : W25QXX_Write_SR
;  *    @Description         : 	дW25QXX״̬Ĵ					
;  *    @IN_Parameter        :  ֻSPR,TB,BP2,BP1,BP0
								(bit 7,5,4,3,2)д!!!
;  *    @Return parameter    :
;  ***********************************************/
void W25QXX_Write_SR(uint8_t sr)
{
	W25QXX_CS = 0;							 //ʹ
	SPI1_ReadWriteByte(W25X_WriteStatusReg); //дȡ״̬Ĵ
	SPI1_ReadWriteByte(sr);					 //дһֽ
	W25QXX_CS = 1;							 //ȡƬѡ
}
/************************************************
;  *    @Function Name       : W25QXX_Write_Enable
;  *    @Description         : W25QXXдʹ  WELλ
;  *    @IN_Parameter        :
;  *    @Return parameter    :
;  ***********************************************/
void W25QXX_Write_Enable(void)
{
	W25QXX_CS = 0;						  //ʹ
	SPI1_ReadWriteByte(W25X_WriteEnable); //дʹ
	W25QXX_CS = 1;						  //ȡƬѡ
}
/************************************************
;  *    @Function Name       : W25QXX_Write_Disable
;  *    @Description         : W25QXXдֹ  WEL
;  *    @IN_Parameter        :
;  *    @Return parameter    :
;  ***********************************************/
void W25QXX_Write_Disable(void)
{
	W25QXX_CS = 0;						   //ʹ
	SPI1_ReadWriteByte(W25X_WriteDisable); //дָֹ
	W25QXX_CS = 1;						   //ȡƬѡ
}
/************************************************
;  *    @Function Name       : W25QXX_ReadID
;  *    @Description         : ȡоƬID
;  *    @IN_Parameter        :
;  *    @Return parameter    :	0XEF13,ʾоƬͺΪW25Q80
								0XEF14,ʾоƬͺΪW25Q16
								0XEF15,ʾоƬͺΪW25Q32
								0XEF16,ʾоƬͺΪW25Q64
								0XEF17,ʾоƬͺΪW25Q128
;  ***********************************************/
uint16_t W25QXX_ReadID(void)
{
	uint16_t temp = 0;
	W25QXX_CS = 0;
	SPI1_ReadWriteByte(0x90); //ͶȡID
	SPI1_ReadWriteByte(0x00);
	SPI1_ReadWriteByte(0x00);
	SPI1_ReadWriteByte(0x00);
	temp |= SPI1_ReadWriteByte(0xFF) << 8;
	temp |= SPI1_ReadWriteByte(0xFF);
	W25QXX_CS = 1;
	return temp;
}
/************************************************
;  *    @Function Name       : W25QXX_Read
;  *    @Description         : ȡSPI FLASH
;  *    @IN_Parameter        :	pBuffer:ݴ洢
								ReadAddr:ʼȡĵַ(24bit)
								NumByteToRead:Ҫȡֽ(65535)
;  *    @Return parameter    :
;  ***********************************************/
void W25QXX_Read(uint8_t *pBuffer, uint32_t ReadAddr, uint16_t NumByteToRead)
{
	uint16_t i;
	W25QXX_CS = 0;									 //ʹ
	SPI1_ReadWriteByte(W25X_ReadData);				 //Ͷȡ
	SPI1_ReadWriteByte((uint8_t)((ReadAddr) >> 16)); //24bitַ
	SPI1_ReadWriteByte((uint8_t)((ReadAddr) >> 8));
	SPI1_ReadWriteByte((uint8_t)ReadAddr);
	for (i = 0; i < NumByteToRead; i++)
	{
		pBuffer[i] = SPI1_ReadWriteByte(0XFF); //ѭ
	}
	W25QXX_CS = 1;
}
/************************************************
;  *    @Function Name       : W25QXX_Write_Page
;  *    @Description         : дҳ
;  *    @IN_Parameter        :	pBuffer:ݴ洢
								WriteAddr:ʼдĵַ(24bit)
								NumByteToWrite:Ҫдֽ(256),
								Ӧóҳʣֽ!!!
;  *    @Return parameter    :
;  ***********************************************/
void W25QXX_Write_Page(uint8_t *pBuffer, uint32_t WriteAddr, uint16_t NumByteToWrite)
{
	uint16_t i;
	W25QXX_Write_Enable();							  //SET WEL
	W25QXX_CS = 0;									  //ʹ
	SPI1_ReadWriteByte(W25X_PageProgram);			  //дҳ
	SPI1_ReadWriteByte((uint8_t)((WriteAddr) >> 16)); //24bitַ
	SPI1_ReadWriteByte((uint8_t)((WriteAddr) >> 8));
	SPI1_ReadWriteByte((uint8_t)WriteAddr);
	for (i = 0; i < NumByteToWrite; i++)
		SPI1_ReadWriteByte(pBuffer[i]); //ѭд
	W25QXX_CS = 1;						//ȡƬѡ
	W25QXX_Wait_Busy();					//ȴд
}
/************************************************
;  *    @Function Name       : W25QXX_Write_NoCheck
;  *    @Description         : ޼дSPI FLASH
								ȷдĵַΧڵȫΪ0XFF,
								ڷ0XFFдݽʧ!
								Զҳܣ
								ַָʼдָȵ,ҪȷַԽ!
;  *    @IN_Parameter        :	pBuffer:ݴ洢
								WriteAddr:ʼдĵַ(24bit)
								NumByteToWrite:Ҫдֽ(65535)
;  *    @Return parameter    :
;  ***********************************************/
void W25QXX_Write_NoCheck(uint8_t *pBuffer, uint32_t WriteAddr, uint16_t NumByteToWrite)
{
	uint16_t pageremain;
	pageremain = 256 - WriteAddr % 256; //ҳʣֽ
	if (NumByteToWrite <= pageremain)
		pageremain = NumByteToWrite; //256ֽ
	while (1)
	{
		W25QXX_Write_Page(pBuffer, WriteAddr, pageremain);
		if (NumByteToWrite == pageremain)
			break; //д
		else	   //NumByteToWrite>pageremain
		{
			pBuffer += pageremain;
			WriteAddr += pageremain;

			NumByteToWrite -= pageremain; //ȥѾд˵ֽ
			if (NumByteToWrite > 256)
				pageremain = 256; //һοд256ֽ
			else
				pageremain = NumByteToWrite; //256ֽ
		}
	}
}
/************************************************
;  *    @Function Name       : W25QXX_Erase_Chip
;  *    @Description         : оƬ
;  *    @IN_Parameter        :
;  *    @Return parameter    :
;  ***********************************************/
void W25QXX_Erase_Chip(void)
{
	W25QXX_Write_Enable(); //SET WEL
	W25QXX_Wait_Busy();
	W25QXX_CS = 0;						//ʹ
	SPI1_ReadWriteByte(W25X_ChipErase); //Ƭ
	W25QXX_CS = 1;						//ȡƬѡ
	W25QXX_Wait_Busy();					//ȴоƬ
}
/************************************************
;  *    @Function Name       : W25QXX_Erase_Sector
;  *    @Description         : һ
;  *    @IN_Parameter        :
;  *    @Return parameter    :
;  ***********************************************/
void W25QXX_Erase_Sector(uint32_t Dst_Addr)
{
	//falsh,
	//	printf("fe:%x\r\n", Dst_Addr);
	Dst_Addr *= 4096;
	W25QXX_Write_Enable(); //SET WEL
	W25QXX_Wait_Busy();
	W25QXX_CS = 0;									 //ʹ
	SPI1_ReadWriteByte(W25X_SectorErase);			 //ָ
	SPI1_ReadWriteByte((uint8_t)((Dst_Addr) >> 16)); //24bitַ
	SPI1_ReadWriteByte((uint8_t)((Dst_Addr) >> 8));
	SPI1_ReadWriteByte((uint8_t)Dst_Addr);
	W25QXX_CS = 1;		//ȡƬѡ
	W25QXX_Wait_Busy(); //ȴ
}
/************************************************
;  *    @Function Name       : W25QXX_Wait_Busy
;  *    @Description         : ȴ
;  *    @IN_Parameter        :
;  *    @Return parameter    :
;  ***********************************************/
void W25QXX_Wait_Busy(void)
{
	while ((W25QXX_ReadSR() & 0x01) == 0x01); // ȴBUSYλ
}
/************************************************
;  *    @Function Name       : W25QXX_PowerDown
;  *    @Description         : ģʽ
;  *    @IN_Parameter        :
;  *    @Return parameter    :
;  ***********************************************/
void W25QXX_PowerDown(void)
{
	W25QXX_CS = 0;						//ʹ
	SPI1_ReadWriteByte(W25X_PowerDown); //͵
	W25QXX_CS = 1;						//ȡƬѡ
	NOP(20);							//ȴTPD
}
/************************************************
;  *    @Function Name       : W25QXX_WAKEUP
;  *    @Description         : 
;  *    @IN_Parameter        :
;  *    @Return parameter    :
;  ***********************************************/
void W25QXX_WAKEUP(void)
{
	W25QXX_CS = 0;							   //ʹ
	SPI1_ReadWriteByte(W25X_ReleasePowerDown); //  send W25X_PowerDown command 0xAB
	W25QXX_CS = 1;							   //ȡƬѡ
	NOP(20);								   //ȴTRES1
}

/**************************** end of file *********************************************/
